Subject: IPP>PRO lengths versus delimiting characters

From: Roger K Debry <[email-masked]>
Date: Fri, 13 Jun 1997 07:46:12 -0400

In IBM's IPDS data stream we have used what we call "triplets" for over a
decade in encoding infomation in the data stream.
A triplet is a structure of the form:

length - 2 bytes
id - 2 bytes
data - n bytes, where n is defined by the length field.

All IDs are registered and define the type of data and associated semantic if
any of the content.

Roger K deBry
Senior Techncial Staff Member
Architecture and Technology
IBM Printing Systems
email: [email-masked]
phone: 1-303-924-4080

---------------------- Forwarded by Roger K Debry/Boulder/IBM on 06/13/97 05:37
AM ---------------------------

        ipp-owner @ pwg.org
        06/12/97 08:25 PM
Please respond to [email-masked] @ internet

To: ipp @ pwg.org @ internet
cc:
Subject: IPP>PRO lengths versus delimiting characters

I was asked to write the rules for delimiting characters in different
encodings.

But after thinking some more and talking to another protocol expert,
I believe that using binary lengths is a better solution than having
delimiting characters because it avoids the escape-character problem.
The escape-character problem has simple solutions, but length is
even simpler.

He also looked at the hybrid solution where the name is delimited
by a colon and the value is determined by a length field prefix.
He agreed with me that this is a strange solution that doesn't seem
right.

I think that we need to think of the application/ipp entity as a binary
encoding that has nothing to do with HTTP headers. So it need not have
headers that look like HTTP headers.

Bob Herriot